<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
 xsi:schemaLocation="http://www.example.org/history history.xsd"
 xmlns:h="http://www.example.org/history" xmlns:x="http://www.w3.org/1999/xhtml">
 <xsl:output method="xml" standalone="yes" indent="yes" />
 <xsl:template match="/">
  <x:html>
   <x:head>
    <x:title>Interesting history page</x:title>
   </x:head>
   <x:body>
    <x:h1>Heroes of the world</x:h1>
    <x:p>Sum of heights: <xsl:value-of select="sum(h:history/h:people/h:class/h:person/@height)"/>cm</x:p> 
     <x:ul>
      <xsl:apply-templates select="h:history/h:people/h:class/h:person">
       <xsl:sort select="@height" data-type="number"/>
      </xsl:apply-templates>
     </x:ul>
    <x:h1>Events</x:h1>
    Groupped by place.
    <xsl:apply-templates select="h:history/h:places/h:place[@id=/h:history/h:events/h:event/h:place/@where]"/>
   </x:body>
  </x:html>
 </xsl:template>

 <xsl:template match="h:person">
  <x:li>
   <xsl:value-of select="@name"/>:
   <xsl:element name="x:div">
    <xsl:attribute name="style">background:green;height:2em;width:<xsl:value-of select="@height"/>pt</xsl:attribute>
    <xsl:text>Height:</xsl:text><xsl:value-of select="@height"/>cm
   </xsl:element>
  </x:li>
 </xsl:template>
 
 <xsl:template match="h:event">
  <x:h3><xsl:value-of select="h:description"/></x:h3>
  Took place in <xsl:value-of select="//h:place[@id=current()/h:place/@where]/h:name"/>, participants:
  <x:ul>
   <xsl:apply-templates select="/h:history/h:people/h:class/h:person[@id=current()/h:participant/@who]"/>
  </x:ul>
 </xsl:template>
 
 <xsl:template match="h:place">
  <x:h2><xsl:value-of select="h:name"/></x:h2>
   <xsl:apply-templates select="/h:history/h:events/h:event[h:place/@where=current()/@id]"/>
 </xsl:template>
</xsl:stylesheet>